"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = featureLoader;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var React = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _reduxFeatures = require("redux-features");

var _reselect = require("reselect");

var _lodash = require("lodash");

function featureLoader(options) {
  var _defaults = (0, _lodash.defaults)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : undefined;
    },
    getFeatureStates: function getFeatureStates(state) {
      return state ? state.featureStates : undefined;
    }
  }),
      getFeatures = _defaults.getFeatures,
      getFeatureStates = _defaults.getFeatureStates,
      featureId = _defaults.featureId,
      render = _defaults.render;

  var mapStateToProps = (0, _reselect.createSelector)(getFeatures, getFeatureStates, function () {
    var features = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var featureStates = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return {
      feature: features[featureId],
      featureState: featureStates[featureId]
    };
  });

  function mergeProps(_ref, _ref2, props) {
    var feature = _ref.feature,
        featureState = _ref.featureState;
    var dispatch = _ref2.dispatch;
    return {
      dispatch: dispatch,
      featureState: featureState,
      children: render ? render({
        feature: feature,
        featureState: featureState,
        props: props
      }) : null
    };
  }

  var FeatureLoader =
  /*#__PURE__*/
  function (_React$Component) {
    (0, _inherits2.default)(FeatureLoader, _React$Component);

    function FeatureLoader() {
      (0, _classCallCheck2.default)(this, FeatureLoader);
      return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(FeatureLoader).apply(this, arguments));
    }

    (0, _createClass2.default)(FeatureLoader, [{
      key: "componentWillMount",
      value: function componentWillMount() {
        var _this$props = this.props,
            featureState = _this$props.featureState,
            dispatch = _this$props.dispatch;
        if (featureState === 'NOT_LOADED') dispatch((0, _reduxFeatures.loadFeature)(featureId));
      }
    }, {
      key: "render",
      value: function render() {
        return this.props.children;
      }
    }]);
    return FeatureLoader;
  }(React.Component);

  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureLoader);
}